Index: trunk/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 42)
+++ trunk/source/App/TAppEncoder/TAppEncTop.cpp	(revision 56)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.
+ * granted under this license.  
  *
- * Copyright (c) 2010-2011, ISO/IEC
+ * Copyright (c) 2010-2012, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -15,5 +15,5 @@
  *    this list of conditions and the following disclaimer in the documentation
  *    and/or other materials provided with the distribution.
- *  * Neither the name of the ISO/IEC nor the names of its contributors may
+ *  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
  *    be used to endorse or promote products derived from this software without
  *    specific prior written permission.
@@ -32,6 +32,4 @@
  */
 
-
-
 /** \file     TAppEncTop.cpp
     \brief    Encoder application class
@@ -39,4 +37,6 @@
 
 #include <list>
+#include <fstream>
+#include <stdlib.h>
 #include <stdio.h>
 #include <fcntl.h>
@@ -44,4 +44,10 @@
 
 #include "TAppEncTop.h"
+#include "TLibEncoder/AnnexBwrite.h"
+
+using namespace std;
+
+//! \ingroup TAppEncoder
+//! \{
 
 // ====================================================================================================================
@@ -51,7 +57,6 @@
 TAppEncTop::TAppEncTop()
 {
-#if HHI_VSO
-  m_iLastFramePutInERViewBuffer = -1;
-#endif
+  m_totalBytes = 0;
+  m_essentialBytes = 0;
 }
 
@@ -60,55 +65,114 @@
 }
 
-
 Void TAppEncTop::xInitLibCfg()
 {
   for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
   {
-    m_iFrameRcvdVector.push_back(0) ;
-    m_acTEncTopList.push_back(new TEncTop);
-
+    m_frameRcvd.push_back(0);
+    m_acTEncTopList.push_back(new TEncTop); 
     m_acTVideoIOYuvInputFileList.push_back(new TVideoIOYuv);
-
     m_acTVideoIOYuvReconFileList.push_back(new TVideoIOYuv);
-    m_cListPicYuvRecList.push_back(new TComList<TComPicYuv*>) ;
-    m_aiNextPocToDump.push_back( 0 );
-    m_cListPicYuvRecMap.push_back( std::map<PicOrderCnt,TComPicYuv*>() );
+    m_picYuvRec.push_back(new TComList<TComPicYuv*>) ;
+
     m_acTEncTopList[iViewIdx]->setFrameRate                    ( m_iFrameRate );
     m_acTEncTopList[iViewIdx]->setFrameSkip                    ( m_FrameSkip );
     m_acTEncTopList[iViewIdx]->setSourceWidth                  ( m_iSourceWidth );
     m_acTEncTopList[iViewIdx]->setSourceHeight                 ( m_iSourceHeight );
+#if PIC_CROPPING
+    m_acTEncTopList[iViewIdx]->setCroppingMode                 ( m_croppingMode );
+    m_acTEncTopList[iViewIdx]->setCropLeft                     ( m_cropLeft );
+    m_acTEncTopList[iViewIdx]->setCropRight                    ( m_cropRight );
+    m_acTEncTopList[iViewIdx]->setCropTop                      ( m_cropTop );
+    m_acTEncTopList[iViewIdx]->setCropBottom                   ( m_cropBottom );
+#endif
     m_acTEncTopList[iViewIdx]->setFrameToBeEncoded             ( m_iFrameToBeEncoded );
+    m_acTEncTopList[iViewIdx]->setViewId                       ( iViewIdx );
+    m_acTEncTopList[iViewIdx]->setIsDepth                      ( false );
+    m_acTEncTopList[iViewIdx]->setViewOrderIdx                 ( m_cCameraData.getViewOrderIndex()[ iViewIdx ] );
+    m_acTEncTopList[iViewIdx]->setCamParPrecision              ( m_cCameraData.getCamParsCodedPrecision  () );
+    m_acTEncTopList[iViewIdx]->setCamParInSliceHeader          ( m_cCameraData.getVaryingCameraParameters() );
+    m_acTEncTopList[iViewIdx]->setCodedScale                   ( m_cCameraData.getCodedScale             () );
+    m_acTEncTopList[iViewIdx]->setCodedOffset                  ( m_cCameraData.getCodedOffset            () );
 
   //====== Coding Structure ========
-#if DCM_DECODING_REFRESH
+    m_acTEncTopList[iViewIdx]->setIntraPeriod                  ( m_iIntraPeriod );
     m_acTEncTopList[iViewIdx]->setDecodingRefreshType          ( m_iDecodingRefreshType );
-#endif
-    m_acTEncTopList[iViewIdx]->setCPSSize                      ( m_uiCodedPictureStoreSize );
     m_acTEncTopList[iViewIdx]->setGOPSize                      ( m_iGOPSize );
-    m_acTEncTopList[iViewIdx]->setRateGOPSize                  ( m_iRateGOPSize );
-
-    m_acTEncTopList[iViewIdx]->setSeqStructure                              ( m_cInputFormatString );
-
+    m_acTEncTopList[iViewIdx]->setGopList                      ( m_GOPListsMvc[iViewIdx] );
+    m_acTEncTopList[iViewIdx]->setExtraRPSs                    ( m_extraRPSs[iViewIdx] );
+#if H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
+    for(Int i = 0; i < MAX_TLAYER; i++)
+    {
+      m_acTEncTopList[iViewIdx]->setNumReorderPics             ( m_numReorderPics[iViewIdx][i], i );
+      m_acTEncTopList[iViewIdx]->setMaxDecPicBuffering         ( m_maxDecPicBuffering[iViewIdx][i], i );
+    }
+#else
+    m_acTEncTopList[iViewIdx]->setNumReorderFrames             ( m_numReorderFrames );
+    m_acTEncTopList[iViewIdx]->setMaxNumberOfReferencePictures ( m_maxNumberOfReferencePictures );
+#endif
+    for( UInt uiLoop = 0; uiLoop < MAX_TLAYER; ++uiLoop )
+    {
+      m_acTEncTopList[iViewIdx]->setLambdaModifier( uiLoop, m_adLambdaModifier[ uiLoop ] );
+    }
     m_acTEncTopList[iViewIdx]->setQP                           ( m_aiQP[0] );
-
+  
     m_acTEncTopList[iViewIdx]->setTemporalLayerQPOffset        ( m_aiTLayerQPOffset );
     m_acTEncTopList[iViewIdx]->setPad                          ( m_aiPad );
-
-    //===== Slice ========
-
-    //====== Entropy Coding ========
-    m_acTEncTopList[iViewIdx]->setSymbolMode                   ( m_iSymbolMode );
-
-    //====== Loop/Deblock Filter ========
-    m_acTEncTopList[iViewIdx]->setLoopFilterDisable            ( m_abLoopFilterDisable[0]   );
-    m_acTEncTopList[iViewIdx]->setLoopFilterAlphaC0Offset      ( m_iLoopFilterAlphaC0Offset );
-    m_acTEncTopList[iViewIdx]->setLoopFilterBetaOffset         ( m_iLoopFilterBetaOffset    );
-
-    //====== Motion search ========
+    
+#if H0566_TLA
+    m_acTEncTopList[iViewIdx]->setMaxTempLayer                 ( m_maxTempLayer[iViewIdx] );
+#else
+    m_acTEncTopList[iViewIdx]->setTLayering                    ( m_bTLayering );
+    m_acTEncTopList[iViewIdx]->setTLayerSwitchingFlag          ( m_abTLayerSwitchingFlag );
+#endif
+
+    m_acTEncTopList[iViewIdx]->setDisInter4x4                  ( m_bDisInter4x4);
+  
+    m_acTEncTopList[iViewIdx]->setUseNSQT( m_enableNSQT );
+    m_acTEncTopList[iViewIdx]->setUseAMP( m_enableAMP );
+  
+  //===== Slice ========
+  
+  //====== Loop/Deblock Filter ========
+    m_acTEncTopList[iViewIdx]->setLoopFilterDisable            ( m_abLoopFilterDisable[0]       );
+    m_acTEncTopList[iViewIdx]->setLoopFilterOffsetInAPS        ( m_loopFilterOffsetInAPS );
+    m_acTEncTopList[iViewIdx]->setLoopFilterBetaOffset         ( m_loopFilterBetaOffsetDiv2  );
+    m_acTEncTopList[iViewIdx]->setLoopFilterTcOffset           ( m_loopFilterTcOffsetDiv2    );
+#if DBL_CONTROL
+    m_acTEncTopList[iViewIdx]->setDeblockingFilterControlPresent( m_DeblockingFilterControlPresent);
+#endif
+
+  //====== Motion search ========
     m_acTEncTopList[iViewIdx]->setFastSearch                   ( m_iFastSearch  );
     m_acTEncTopList[iViewIdx]->setSearchRange                  ( m_iSearchRange );
     m_acTEncTopList[iViewIdx]->setBipredSearchRange            ( m_bipredSearchRange );
+
+  //====== Quality control ========
     m_acTEncTopList[iViewIdx]->setMaxDeltaQP                   ( m_iMaxDeltaQP  );
-
+    m_acTEncTopList[iViewIdx]->setMaxCuDQPDepth                ( m_iMaxCuDQPDepth  );
+
+    m_acTEncTopList[iViewIdx]->setChromaQpOffset               ( m_iChromaQpOffset     );
+    m_acTEncTopList[iViewIdx]->setChromaQpOffset2nd            ( m_iChromaQpOffset2nd  );
+
+#if ADAPTIVE_QP_SELECTION
+    m_acTEncTopList[iViewIdx]->setUseAdaptQpSelect             ( m_bUseAdaptQpSelect   );
+#endif
+
+#if LOSSLESS_CODING
+    Int lowestQP;
+#if H0736_AVC_STYLE_QP_RANGE
+    lowestQP =  - ( (Int)(6*(g_uiBitDepth + g_uiBitIncrement - 8)) );
+#else
+    lowestQP = 0;
+#endif
+    if ((m_iMaxDeltaQP == 0 ) && (m_aiQP[0] == lowestQP) && (m_useLossless == true))
+    {
+      m_bUseAdaptiveQP = false;
+    }
+#endif
+
+    m_acTEncTopList[iViewIdx]->setUseAdaptiveQP                ( m_bUseAdaptiveQP  );
+    m_acTEncTopList[iViewIdx]->setQPAdaptationRange            ( m_iQPAdaptationRange );
+  
 #if HHI_VSO
     //====== VSO =========
@@ -116,7 +180,23 @@
     m_acTEncTopList[iViewIdx]->setLambdaScaleVSO               ( 1     );
     m_acTEncTopList[iViewIdx]->setVSOMode                      ( 0     );
-#endif
-
-    //====== Tool list ========
+    m_acTEncTopList[iViewIdx]->setUseVSO                       ( false ); //GT: might be enabled later for VSO Mode 4
+#endif
+
+#if DEPTH_MAP_GENERATION
+    m_acTEncTopList[iViewIdx]->setPredDepthMapGeneration       ( m_uiPredDepthMapGeneration );
+    m_acTEncTopList[iViewIdx]->setPdmPrecision                 ( (UInt)m_cCameraData.getPdmPrecision     () );
+    m_acTEncTopList[iViewIdx]->setPdmScaleNomDelta             (       m_cCameraData.getPdmScaleNomDelta () );
+    m_acTEncTopList[iViewIdx]->setPdmOffset                    (       m_cCameraData.getPdmOffset        () );
+#endif
+#if HHI_INTER_VIEW_MOTION_PRED
+    m_acTEncTopList[iViewIdx]->setMultiviewMvPredMode          ( m_uiMultiviewMvPredMode );
+    m_acTEncTopList[iViewIdx]->setMultiviewMvRegMode           ( iViewIdx ? m_uiMultiviewMvRegMode       : 0   );
+    m_acTEncTopList[iViewIdx]->setMultiviewMvRegLambdaScale    ( iViewIdx ? m_dMultiviewMvRegLambdaScale : 0.0 );
+#endif
+#if HHI_INTER_VIEW_RESIDUAL_PRED
+    m_acTEncTopList[iViewIdx]->setMultiviewResPredMode         ( m_uiMultiviewResPredMode );
+#endif
+
+  //====== Tool list ========
     m_acTEncTopList[iViewIdx]->setUseSBACRD                    ( m_bUseSBACRD   );
     m_acTEncTopList[iViewIdx]->setDeltaQpRD                    ( m_uiDeltaQpRD  );
@@ -124,15 +204,17 @@
     m_acTEncTopList[iViewIdx]->setUseHADME                     ( m_bUseHADME    );
     m_acTEncTopList[iViewIdx]->setUseALF                       ( m_abUseALF[0]  );
-#if MQT_ALF_NPASS
     m_acTEncTopList[iViewIdx]->setALFEncodePassReduction       ( m_iALFEncodePassReduction );
-#endif
-#if DCM_COMB_LIST
+#if LOSSLESS_CODING
+    m_acTEncTopList[iViewIdx]->setUseLossless                  ( m_useLossless );
+#endif
+    m_acTEncTopList[iViewIdx]->setALFMaxNumberFilters          ( m_iALFMaxNumberFilters ) ;
+
     m_acTEncTopList[iViewIdx]->setUseLComb                     ( m_bUseLComb    );
     m_acTEncTopList[iViewIdx]->setLCMod                        ( m_bLCMod         );
-#endif
     m_acTEncTopList[iViewIdx]->setdQPs                         ( m_aidQP        );
     m_acTEncTopList[iViewIdx]->setUseRDOQ                      ( m_abUseRDOQ[0] );
-    m_acTEncTopList[iViewIdx]->setUseLDC                       ( m_bUseLDC      );
+#if !PIC_CROPPING
     m_acTEncTopList[iViewIdx]->setUsePAD                       ( m_bUsePAD      );
+#endif
     m_acTEncTopList[iViewIdx]->setQuadtreeTULog2MaxSize        ( m_uiQuadtreeTULog2MaxSize );
     m_acTEncTopList[iViewIdx]->setQuadtreeTULog2MinSize        ( m_uiQuadtreeTULog2MinSize );
@@ -140,150 +222,171 @@
     m_acTEncTopList[iViewIdx]->setQuadtreeTUMaxDepthIntra      ( m_uiQuadtreeTUMaxDepthIntra );
     m_acTEncTopList[iViewIdx]->setUseFastEnc                   ( m_bUseFastEnc  );
-
-#if HHI_VSO
-    m_acTEncTopList[iViewIdx]->setUseVSO                       ( false ); //GT: might be enabled later for VSO Mode 4
-#endif
-
-#if BITSTREAM_EXTRACTION
-    m_acTEncTopList[iViewIdx]->setLayerId                      ( ( (UInt)iViewIdx ) << 1 );
-#endif
-    m_acTEncTopList[iViewIdx]->setViewId                       ( (UInt)iViewIdx );
-    m_acTEncTopList[iViewIdx]->setViewOrderIdx                 ( m_cCameraData.getViewOrderIndex()[ iViewIdx ] );
-    m_acTEncTopList[iViewIdx]->setIsDepth                      ( false );
-    m_acTEncTopList[iViewIdx]->setCamParPrecision              ( m_cCameraData.getCamParsCodedPrecision  () );
-    m_acTEncTopList[iViewIdx]->setCamParInSliceHeader          ( m_cCameraData.getVaryingCameraParameters() );
-    m_acTEncTopList[iViewIdx]->setCodedScale                   ( m_cCameraData.getCodedScale             () );
-    m_acTEncTopList[iViewIdx]->setCodedOffset                  ( m_cCameraData.getCodedOffset            () );
-#if DEPTH_MAP_GENERATION
-    m_acTEncTopList[iViewIdx]->setPredDepthMapGeneration       ( m_uiPredDepthMapGeneration );
-    m_acTEncTopList[iViewIdx]->setPdmPrecision                 ( (UInt)m_cCameraData.getPdmPrecision     () );
-    m_acTEncTopList[iViewIdx]->setPdmScaleNomDelta             (       m_cCameraData.getPdmScaleNomDelta () );
-    m_acTEncTopList[iViewIdx]->setPdmOffset                    (       m_cCameraData.getPdmOffset        () );
-#endif
-#if HHI_INTER_VIEW_MOTION_PRED
-    m_acTEncTopList[iViewIdx]->setMultiviewMvPredMode          ( m_uiMultiviewMvPredMode );
-    m_acTEncTopList[iViewIdx]->setMultiviewMvRegMode           ( iViewIdx ? m_uiMultiviewMvRegMode       : 0   );
-    m_acTEncTopList[iViewIdx]->setMultiviewMvRegLambdaScale    ( iViewIdx ? m_dMultiviewMvRegLambdaScale : 0.0 );
-#endif
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-    m_acTEncTopList[iViewIdx]->setMultiviewResPredMode         ( m_uiMultiviewResPredMode );
-#endif
-
-
+    m_acTEncTopList[iViewIdx]->setUseEarlyCU                   ( m_bUseEarlyCU  ); 
+#if FAST_DECISION_FOR_MRG_RD_COST
+    m_acTEncTopList[iViewIdx]->setUseFastDecisionForMerge      ( m_useFastDecisionForMerge  );
+#endif
+    m_acTEncTopList[iViewIdx]->setUseCbfFastMode               ( m_bUseCbfFastMode  );
 #if HHI_INTERVIEW_SKIP
-    m_acTEncTopList[iViewIdx]->setInterViewSkip            ( iViewIdx ? m_uiInterViewSkip : 0 );
+    m_acTEncTopList[iViewIdx]->setInterViewSkip            ( iViewIdx>0 ? m_bInterViewSkip : false );
 #if HHI_INTERVIEW_SKIP_LAMBDA_SCALE
-    m_acTEncTopList[iViewIdx]->setInterViewSkipLambdaScale ( iViewIdx ? (Int)m_dInterViewSkipLambdaScale : 1 );
-#endif
-#endif
-    m_acTEncTopList[iViewIdx]->setUseMRG                       ( m_bUseMRG      ); // SOPH:
-
-#if LM_CHROMA
+    m_acTEncTopList[iViewIdx]->setInterViewSkipLambdaScale ( iViewIdx>0 ? (UInt)m_dInterViewSkipLambdaScale : 1 );
+#endif
+#endif
     m_acTEncTopList[iViewIdx]->setUseLMChroma                  ( m_bUseLMChroma );
-#endif
-
-#if HHI_RMP_SWITCH
-    m_acTEncTopList[iViewIdx]->setUseRMP                     ( m_bUseRMP );
-#endif
-#ifdef ROUNDING_CONTROL_BIPRED
-    m_acTEncTopList[iViewIdx]->setUseRoundingControlBipred(m_useRoundingControlBipred);
-#endif
+    m_acTEncTopList[iViewIdx]->setUseConstrainedIntraPred      ( m_bUseConstrainedIntraPred );
+    m_acTEncTopList[iViewIdx]->setPCMLog2MinSize               ( m_uiPCMLog2MinSize);
+    m_acTEncTopList[iViewIdx]->setUsePCM                       ( m_usePCM );
+    m_acTEncTopList[iViewIdx]->setPCMLog2MaxSize               ( m_pcmLog2MaxSize);
+
+  //====== Weighted Prediction ========
+    m_acTEncTopList[iViewIdx]->setUseWP                        ( m_bUseWeightPred      );
+    m_acTEncTopList[iViewIdx]->setWPBiPredIdc                  ( m_uiBiPredIdc         );
+  //====== Slice ========
+    m_acTEncTopList[iViewIdx]->setSliceMode                    ( m_iSliceMode                );
+    m_acTEncTopList[iViewIdx]->setSliceArgument                ( m_iSliceArgument            );
+
+  //====== Entropy Slice ========
+    m_acTEncTopList[iViewIdx]->setEntropySliceMode             ( m_iEntropySliceMode         );
+    m_acTEncTopList[iViewIdx]->setEntropySliceArgument         ( m_iEntropySliceArgument     );
+    int iNumPartInCU = 1<<(m_uiMaxCUDepth<<1);
+    if(m_iEntropySliceMode==SHARP_FIXED_NUMBER_OF_LCU_IN_ENTROPY_SLICE)
+    {
+      m_acTEncTopList[iViewIdx]->setEntropySliceArgument ( m_iEntropySliceArgument * ( iNumPartInCU >> ( m_iSliceGranularity << 1 ) ) );
+    }
+    if(m_iSliceMode==AD_HOC_SLICES_FIXED_NUMBER_OF_LCU_IN_SLICE)
+    {
+      m_acTEncTopList[iViewIdx]->setSliceArgument ( m_iSliceArgument * ( iNumPartInCU >> ( m_iSliceGranularity << 1 ) ) );
+    }
+#if FIXED_NUMBER_OF_TILES_SLICE_MODE
+    if(m_iSliceMode==AD_HOC_SLICES_FIXED_NUMBER_OF_TILES_IN_SLICE)
+    {
+      m_acTEncTopList[iViewIdx]->setSliceArgument ( m_iSliceArgument );
+    }
+#endif
+    m_acTEncTopList[iViewIdx]->setSliceGranularity        ( m_iSliceGranularity         );
+    if(m_iSliceMode == 0 )
+    {
+      m_bLFCrossSliceBoundaryFlag = true;
+    }
+    m_acTEncTopList[iViewIdx]->setLFCrossSliceBoundaryFlag( m_bLFCrossSliceBoundaryFlag );
+    m_acTEncTopList[iViewIdx]->setUseSAO               ( m_abUseSAO[0]     );
+#if SAO_UNIT_INTERLEAVING
+    m_acTEncTopList[iViewIdx]->setMaxNumOffsetsPerPic (m_maxNumOffsetsPerPic);
+    m_acTEncTopList[iViewIdx]->setSaoInterleavingFlag (m_saoInterleavingFlag);
+#endif
+    m_acTEncTopList[iViewIdx]->setPCMInputBitDepthFlag  ( m_bPCMInputBitDepthFlag); 
+    m_acTEncTopList[iViewIdx]->setPCMFilterDisableFlag  ( m_bPCMFilterDisableFlag); 
+
+    m_acTEncTopList[iViewIdx]->setPictureDigestEnabled(m_pictureDigestEnabled);
+
+    m_acTEncTopList[iViewIdx]->setColumnRowInfoPresent       ( m_iColumnRowInfoPresent );
+    m_acTEncTopList[iViewIdx]->setUniformSpacingIdr          ( m_iUniformSpacingIdr );
+#if !REMOVE_TILE_DEPENDENCE
+    m_acTEncTopList[iViewIdx]->setTileBoundaryIndependenceIdr( m_iTileBoundaryIndependenceIdr );
+#endif
+    m_acTEncTopList[iViewIdx]->setNumColumnsMinus1           ( m_iNumColumnsMinus1 );
+    m_acTEncTopList[iViewIdx]->setNumRowsMinus1              ( m_iNumRowsMinus1 );
+    if(m_iUniformSpacingIdr==0)
+    {
+      m_acTEncTopList[iViewIdx]->setColumnWidth              ( m_pchColumnWidth );
+      m_acTEncTopList[iViewIdx]->setRowHeight                ( m_pchRowHeight );
+    }
+    m_acTEncTopList[iViewIdx]->xCheckGSParameters();
+    m_acTEncTopList[iViewIdx]->setTileLocationInSliceHeaderFlag ( m_iTileLocationInSliceHeaderFlag );
+    m_acTEncTopList[iViewIdx]->setTileMarkerFlag              ( m_iTileMarkerFlag );
+    m_acTEncTopList[iViewIdx]->setMaxTileMarkerEntryPoints    ( m_iMaxTileMarkerEntryPoints );
+  
+    Int uiTilesCount          = (m_iNumRowsMinus1+1) * (m_iNumColumnsMinus1+1);
+    m_dMaxTileMarkerOffset    = ((Double)uiTilesCount) / m_iMaxTileMarkerEntryPoints;
+    m_acTEncTopList[iViewIdx]->setMaxTileMarkerOffset         ( m_dMaxTileMarkerOffset );
+    m_acTEncTopList[iViewIdx]->setTileBehaviorControlPresentFlag( m_iTileBehaviorControlPresentFlag );
+#if !REMOVE_TILE_DEPENDENCE
+    if(m_iTileBoundaryIndependenceIdr == 0 || uiTilesCount == 1)
+#else
+    if(uiTilesCount == 1)
+#endif
+    {
+      m_bLFCrossTileBoundaryFlag = true; 
+    }
+    m_acTEncTopList[iViewIdx]->setLFCrossTileBoundaryFlag( m_bLFCrossTileBoundaryFlag );
+    m_acTEncTopList[iViewIdx]->setWaveFrontSynchro           ( m_iWaveFrontSynchro );
+    m_acTEncTopList[iViewIdx]->setWaveFrontFlush             ( m_iWaveFrontFlush );
+    m_acTEncTopList[iViewIdx]->setWaveFrontSubstreams        ( m_iWaveFrontSubstreams );
+    m_acTEncTopList[iViewIdx]->setEnableTMVP ( m_enableTMVP );
+    m_acTEncTopList[iViewIdx]->setUseScalingListId           ( m_useScalingListId  );
+    m_acTEncTopList[iViewIdx]->setScalingListFile            ( m_scalingListFile   );
+#if MULTIBITS_DATA_HIDING
+    m_acTEncTopList[iViewIdx]->setSignHideFlag(m_signHideFlag);
+    m_acTEncTopList[iViewIdx]->setTSIG(m_signHidingThreshold);
+#endif
+
+#if LCU_SYNTAX_ALF
+    if(uiTilesCount > 1)
+    {
+      m_bALFParamInSlice = false;
+      m_bALFPicBasedEncode = true;
+    }
+    m_acTEncTopList[iViewIdx]->setALFParamInSlice              ( m_bALFParamInSlice);
+    m_acTEncTopList[iViewIdx]->setALFPicBasedEncode            ( m_bALFPicBasedEncode);
+#endif
+
+    //====== Depth tools ========
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
-    m_acTEncTopList[iViewIdx]->setUseDMM( false );
-#endif
-#if CONSTRAINED_INTRA_PRED
-    m_acTEncTopList[iViewIdx]->setUseConstrainedIntraPred      ( m_bUseConstrainedIntraPred );
-#endif
-#ifdef WEIGHT_PRED
-    //====== Weighted Prediction ========
-    m_acTEncTopList[iViewIdx]->setUseWP                         ( m_bUseWeightPred      );
-    m_acTEncTopList[iViewIdx]->setWPBiPredIdc                   ( m_uiBiPredIdc         );
-#endif
-    //====== Slice ========
-    m_acTEncTopList[iViewIdx]->setSliceMode               ( m_iSliceMode                );
-    m_acTEncTopList[iViewIdx]->setSliceArgument           ( m_iSliceArgument            );
-
-    //====== Entropy Slice ========
-    m_acTEncTopList[iViewIdx]->setEntropySliceMode        ( m_iEntropySliceMode         );
-    m_acTEncTopList[iViewIdx]->setEntropySliceArgument    ( m_iEntropySliceArgument     );
-#if MTK_NONCROSS_INLOOP_FILTER
-    if(m_iSliceMode == 0 )
-    {
-      m_bLFCrossSliceBoundaryFlag = true;
-    }
-    m_acTEncTopList[iViewIdx]->setLFCrossSliceBoundaryFlag( m_bLFCrossSliceBoundaryFlag );
-#endif
-#if MTK_SAO
-    m_acTEncTopList[iViewIdx]->setUseSAO               ( m_abUseSAO[0]     );
+    m_acTEncTopList[iViewIdx]->setUseDMM                     ( false );
 #endif
 #if HHI_MPI
     m_acTEncTopList[iViewIdx]->setUseMVI( false );
 #endif
-
-    m_acTEncTopList[iViewIdx]->setPictureDigestEnabled(m_pictureDigestEnabled);
-    m_acTEncTopList[iViewIdx]->setQpChangeFrame( m_iQpChangeFrame );
-    m_acTEncTopList[iViewIdx]->setQpChangeOffsetVideo( m_iQpChangeOffsetVideo );
-    m_acTEncTopList[iViewIdx]->setQpChangeOffsetDepth( m_iQpChangeOffsetDepth );
   }
   if( m_bUsingDepthMaps )
   {
-
-#if HHI_VSO
-    for (Int iViewIdx=0; iViewIdx<m_iNumberOfExternalRefs; iViewIdx++)
-    {
-        m_acTVideoIOYuvERFileList.push_back(new TVideoIOYuv);
-    }
-#endif
-
     for(Int iViewIdx=0; iViewIdx<m_iNumberOfViews; iViewIdx++)
     {
-#if FLEX_CODING_ORDER
-      // Detect whether depth comes before than texture for this view
-      Bool isDepthFirst = false;
-      if ( m_b3DVFlexOrder )
-      {
-        for ( Int ii=1; ii<12; ii+=2 )
-        {
-          Int iViewIdxCfg = (Int)(m_pchMVCJointCodingOrder[ii]-'0');
-          if ( iViewIdxCfg == iViewIdx )
-          {
-            if ( m_pchMVCJointCodingOrder[ii-1]=='D' ) // depth comes first for this view
-            {
-              isDepthFirst = true;
-            }
-            else
-            {
-              assert(m_pchMVCJointCodingOrder[ii-1]=='T');
-            }
-            break;
-          }
-        }
-      }
-#endif
-      m_iDepthFrameRcvdVector.push_back(0) ;
-      m_acTEncDepthTopList.push_back(new TEncTop);
-
+      m_depthFrameRcvd.push_back(0);
+      m_acTEncDepthTopList.push_back(new TEncTop); 
       m_acTVideoIOYuvDepthInputFileList.push_back(new TVideoIOYuv);
-
       m_acTVideoIOYuvDepthReconFileList.push_back(new TVideoIOYuv);
-      m_cListPicYuvDepthRecList.push_back(new TComList<TComPicYuv*>) ;
-      m_aiNextDepthPocToDump.push_back( 0 );
-      m_cListPicYuvDepthRecMap.push_back( std::map<PicOrderCnt,TComPicYuv*>() );
+      m_picYuvDepthRec.push_back(new TComList<TComPicYuv*>) ;
+
       m_acTEncDepthTopList[iViewIdx]->setFrameRate                    ( m_iFrameRate );
       m_acTEncDepthTopList[iViewIdx]->setFrameSkip                    ( m_FrameSkip );
       m_acTEncDepthTopList[iViewIdx]->setSourceWidth                  ( m_iSourceWidth );
       m_acTEncDepthTopList[iViewIdx]->setSourceHeight                 ( m_iSourceHeight );
+#if PIC_CROPPING
+      m_acTEncDepthTopList[iViewIdx]->setCroppingMode                 ( m_croppingMode );
+      m_acTEncDepthTopList[iViewIdx]->setCropLeft                     ( m_cropLeft );
+      m_acTEncDepthTopList[iViewIdx]->setCropRight                    ( m_cropRight );
+      m_acTEncDepthTopList[iViewIdx]->setCropTop                      ( m_cropTop );
+      m_acTEncDepthTopList[iViewIdx]->setCropBottom                   ( m_cropBottom );
+#endif
       m_acTEncDepthTopList[iViewIdx]->setFrameToBeEncoded             ( m_iFrameToBeEncoded );
+      m_acTEncDepthTopList[iViewIdx]->setViewId                       ( iViewIdx );
+      m_acTEncDepthTopList[iViewIdx]->setIsDepth                      ( true );
+      m_acTEncDepthTopList[iViewIdx]->setViewOrderIdx                 ( m_cCameraData.getViewOrderIndex()[ iViewIdx ] );
+      m_acTEncDepthTopList[iViewIdx]->setCamParPrecision              ( 0 );
+      m_acTEncDepthTopList[iViewIdx]->setCamParInSliceHeader          ( false );
+      m_acTEncDepthTopList[iViewIdx]->setCodedScale                   ( 0 );
+      m_acTEncDepthTopList[iViewIdx]->setCodedOffset                  ( 0 );
 
       //====== Coding Structure ========
-#if DCM_DECODING_REFRESH
+      m_acTEncDepthTopList[iViewIdx]->setIntraPeriod                  ( m_iIntraPeriod );
       m_acTEncDepthTopList[iViewIdx]->setDecodingRefreshType          ( m_iDecodingRefreshType );
-#endif
-      m_acTEncDepthTopList[iViewIdx]->setCPSSize                      ( m_uiCodedPictureStoreSize );
       m_acTEncDepthTopList[iViewIdx]->setGOPSize                      ( m_iGOPSize );
-      m_acTEncDepthTopList[iViewIdx]->setRateGOPSize                  ( m_iRateGOPSize );
-
-      m_acTEncDepthTopList[iViewIdx]->setSeqStructure                              ( m_cInputFormatString );
-
+      m_acTEncDepthTopList[iViewIdx]->setGopList                      ( m_GOPListsMvc[iViewIdx] );
+      m_acTEncDepthTopList[iViewIdx]->setExtraRPSs                    ( m_extraRPSs[iViewIdx] );
+#if H0567_DPB_PARAMETERS_PER_TEMPORAL_LAYER
+      for(Int i = 0; i < MAX_TLAYER; i++)
+      {
+        m_acTEncDepthTopList[iViewIdx]->setNumReorderPics             ( m_numReorderPics[iViewIdx][i], i );
+        m_acTEncDepthTopList[iViewIdx]->setMaxDecPicBuffering         ( m_maxDecPicBuffering[iViewIdx][i], i );
+      }
+#else
+      m_acTEncDepthTopList[iViewIdx]->setNumReorderFrames             ( m_numReorderFrames );
+      m_acTEncDepthTopList[iViewIdx]->setMaxNumberOfReferencePictures ( m_maxNumberOfReferencePictures );
+#endif
+      for( UInt uiLoop = 0; uiLoop < MAX_TLAYER; ++uiLoop )
+      {
+        m_acTEncDepthTopList[iViewIdx]->setLambdaModifier( uiLoop, m_adLambdaModifier[ uiLoop ] );
+      }
       m_acTEncDepthTopList[iViewIdx]->setQP                           ( m_aiQP[1] );
 
@@ -291,13 +394,26 @@
       m_acTEncDepthTopList[iViewIdx]->setPad                          ( m_aiPad );
 
+#if H0566_TLA
+      m_acTEncDepthTopList[iViewIdx]->setMaxTempLayer                 ( m_maxTempLayer[iViewIdx] );
+#else
+      m_acTEncDepthTopList[iViewIdx]->setTLayering                    ( m_bTLayering );
+      m_acTEncDepthTopList[iViewIdx]->setTLayerSwitchingFlag          ( m_abTLayerSwitchingFlag );
+#endif
+
+      m_acTEncDepthTopList[iViewIdx]->setDisInter4x4                  ( m_bDisInter4x4);
+
+      m_acTEncDepthTopList[iViewIdx]->setUseNSQT( m_enableNSQT );
+      m_acTEncDepthTopList[iViewIdx]->setUseAMP( m_enableAMP );
+
       //===== Slice ========
-
-      //====== Entropy Coding ========
-      m_acTEncDepthTopList[iViewIdx]->setSymbolMode                   ( m_iSymbolMode );
 
       //====== Loop/Deblock Filter ========
       m_acTEncDepthTopList[iViewIdx]->setLoopFilterDisable            ( m_abLoopFilterDisable[1]   );
-      m_acTEncDepthTopList[iViewIdx]->setLoopFilterAlphaC0Offset      ( m_iLoopFilterAlphaC0Offset );
-      m_acTEncDepthTopList[iViewIdx]->setLoopFilterBetaOffset         ( m_iLoopFilterBetaOffset    );
+      m_acTEncDepthTopList[iViewIdx]->setLoopFilterOffsetInAPS        ( m_loopFilterOffsetInAPS );
+      m_acTEncDepthTopList[iViewIdx]->setLoopFilterBetaOffset         ( m_loopFilterBetaOffsetDiv2  );
+      m_acTEncDepthTopList[iViewIdx]->setLoopFilterTcOffset           ( m_loopFilterTcOffsetDiv2    );
+#if DBL_CONTROL
+      m_acTEncDepthTopList[iViewIdx]->setDeblockingFilterControlPresent( m_DeblockingFilterControlPresent);
+#endif
 
       //====== Motion search ========
@@ -305,5 +421,18 @@
       m_acTEncDepthTopList[iViewIdx]->setSearchRange                  ( m_iSearchRange );
       m_acTEncDepthTopList[iViewIdx]->setBipredSearchRange            ( m_bipredSearchRange );
+
+      //====== Quality control ========
       m_acTEncDepthTopList[iViewIdx]->setMaxDeltaQP                   ( m_iMaxDeltaQP  );
+      m_acTEncDepthTopList[iViewIdx]->setMaxCuDQPDepth                ( m_iMaxCuDQPDepth  );
+
+      m_acTEncDepthTopList[iViewIdx]->setChromaQpOffset               ( m_iChromaQpOffset     );
+      m_acTEncDepthTopList[iViewIdx]->setChromaQpOffset2nd            ( m_iChromaQpOffset2nd  );
+
+#if ADAPTIVE_QP_SELECTION
+      m_acTEncDepthTopList[iViewIdx]->setUseAdaptQpSelect             ( m_bUseAdaptQpSelect   );
+#endif
+
+      m_acTEncDepthTopList[iViewIdx]->setUseAdaptiveQP                ( m_bUseAdaptiveQP  );
+      m_acTEncDepthTopList[iViewIdx]->setQPAdaptationRange            ( m_iQPAdaptationRange );
 
       //====== Tool list ========
@@ -313,15 +442,17 @@
       m_acTEncDepthTopList[iViewIdx]->setUseHADME                     ( m_bUseHADME    );
       m_acTEncDepthTopList[iViewIdx]->setUseALF                       ( m_abUseALF[1]  );
-#if MQT_ALF_NPASS
       m_acTEncDepthTopList[iViewIdx]->setALFEncodePassReduction       ( m_iALFEncodePassReduction );
-#endif
-#if DCM_COMB_LIST
+#if LOSSLESS_CODING
+      m_acTEncDepthTopList[iViewIdx]->setUseLossless                  ( m_useLossless );
+#endif
+      m_acTEncDepthTopList[iViewIdx]->setALFMaxNumberFilters          ( m_iALFMaxNumberFilters ) ;
+
       m_acTEncDepthTopList[iViewIdx]->setUseLComb                     ( m_bUseLComb    );
-      m_acTEncDepthTopList[iViewIdx]->setLCMod                        ( m_bLCMod         );
-#endif
-      m_acTEncDepthTopList[iViewIdx]->setdQPs                         ( m_aidQP        );
+      m_acTEncDepthTopList[iViewIdx]->setLCMod                        ( m_bLCMod       );
+      m_acTEncDepthTopList[iViewIdx]->setdQPs                         ( m_aidQPdepth   );
       m_acTEncDepthTopList[iViewIdx]->setUseRDOQ                      ( m_abUseRDOQ[1] );
-      m_acTEncDepthTopList[iViewIdx]->setUseLDC                       ( m_bUseLDC      );
+#if !PIC_CROPPING
       m_acTEncDepthTopList[iViewIdx]->setUsePAD                       ( m_bUsePAD      );
+#endif
       m_acTEncDepthTopList[iViewIdx]->setQuadtreeTULog2MaxSize        ( m_uiQuadtreeTULog2MaxSize );
       m_acTEncDepthTopList[iViewIdx]->setQuadtreeTULog2MinSize        ( m_uiQuadtreeTULog2MinSize );
